# Rust web-ohjelmointikielenä

Opinnäytetyön tavoitteena on selvittää Rust-ohjelmointikielen
soveltuvuutta web-ohjelmointiin.

Opinnäytetyön yhteydessä on tehty suhteellisen pieni
projekti, missä frontend ja backend on toteutettu molemmat
Rustilla.

Rust on Mozillan 2010 julkaisema ohjelmointikieli. Se on hyvin
suorituskykyinen järjestelmätason ohjelmointikieli, muistuttaen
monilta osin C ja C++ kieliä. Rustin tarkoituksena on säilyttää
näiden vanhojen kielien suorituskyky, mutta kuitenkin tarjoten
samalla muun muassa vahvan tyypityksen, ratkaista tyypilliset
C-kielien muistinhallintaongelmat, turvallisen rinnakkaisajon.

Lisäksi Rust kokoontuu suoraan WebAssemblyksi, mikä on myös
omalta osaltaan kerännyt hyvin paljon kiinnostusta lähivuosina.
Sitä on suunniteltu JavaScriptin seuraajaksi ja sen etuna on
Rustin tavoin huomattavasti parempi tehokkuus ja suorituskyky.

Opinnäytetyön projektissa olen käyttävänyt Yew
frameworkiä, mikä on Rustilla toteutettu asiakaspuolen framework
joka kokoontuu WebAssemblyksi. Lisää tietoa siitä voi lukea
[täältä](https://yew.rs)

Backend puolella käytin Actixia, joka on hyvin JavaScript-
maailmasta tutun Node.js Expressin kaltainen. Siitä voi lukea
lisää tietoa [täältä](https://actix.rs)
